LeetCode 73 - Unique Paths II


Follow up for LeetCode - Unique Paths. Now consider if some obstacles are added to the grids. How many unique paths would there be? An obstacle and empty space is marked as 1 and 0 respectively in the grid.
There is one obstacle in the middle of a 3x3 grid as illustrated below.
[
  [0,0,0],
  [0,1,0],
  [0,0,0]
]
The total number of unique paths is 2
dp[i][j]={0dp[i1][j]+dp[i][j1]if grid[i][j]=1otherwise.

Then we can scan the grid in the row-major manner and update dp[i][j] accordingly. Finally,dp[m1][n1] is what we want. Since dp[i][j] depend on grid[i][j] and the two cells to its left and top, a whole table for dp is not necessary; an array of length n suffices (or of lengthm , depending on the implementation). To avoid boundary check, an array of length n+1 is used below.
X. O(1): reuse input
https://leetcode.com/discuss/15756/java-solution-using-dynamic-programming-o-1-space
Say for example, you are looking at an element in the first row (row 0), and there's an obstacle in the second column (col 1), because for elements in the first row, the only possible path from (0,0) is to keep going right, (0, 1), (0, 2) ... Any obstacles in the way will block this path for all elements to the right of it.
Now let's look at how this logic is implemented in code. If there is an obstacle in the first row (i == 0), the first if statement, if(obstacleGrid[i][j] == 1) obstacleGrid[i][j] = 0; will turn this element into 0. Any elements to its right (with larger j values) will be turned into 0 by the third statement obstacleGrid[i][j] = obstacleGrid[i][j - 1] * 1, meaning we cannot get to (i,j) from (0,0). Well of course that's the case, because the only path to (i,j) is blocked by the obstacle in first row
    public int uniquePathsWithObstacles(int[][] obstacleGrid) {
        
        //Empty case
        if(obstacleGrid.length == 0) return 0;
        
        int rows = obstacleGrid.length;
        int cols = obstacleGrid[0].length;
        
        for(int i = 0; i < rows; i++){
            for(int j = 0; j < cols; j++){
                if(obstacleGrid[i][j] == 1)
                    obstacleGrid[i][j] = 0;
                else if(i == 0 && j == 0)
                    obstacleGrid[i][j] = 1;
                else if(i == 0)
                    obstacleGrid[i][j] = obstacleGrid[i][j - 1] * 1;// For row 0, if there are no paths to left cell, then its 0,else 1
                else if(j == 0)
                    obstacleGrid[i][j] = obstacleGrid[i - 1][j] * 1;// For col 0, if there are no paths to upper cell, then its 0,else 1
                else
                    obstacleGrid[i][j] = obstacleGrid[i - 1][j] + obstacleGrid[i][j - 1];
            }
        }
        
        return obstacleGrid[rows - 1][cols - 1];
        
    }
https://discuss.leetcode.com/topic/9687/easy-java-solution-in-place-dp
        public int uniquePathsWithObstacles(int[][] obstacleGrid) {
            int m = obstacleGrid.length;
            int n = obstacleGrid[0].length;
    
            obstacleGrid[0][0]^=1;
            for(int i = 1;i<m;i++){
                obstacleGrid[i][0]=(obstacleGrid[i][0]==1)? 0:obstacleGrid[i-1][0];
            }
            
            for(int j = 1;j<n;j++){
                obstacleGrid[0][j] =(obstacleGrid[0][j]==1)? 0: obstacleGrid[0][j-1];
            }
            for(int i = 1;i<m;i++){
                for(int j =1;j<n;j++){
                    obstacleGrid[i][j] =(obstacleGrid[i][j]==1)? 0: obstacleGrid[i-1][j]+obstacleGrid[i][j-1];
                }
            }
            return obstacleGrid[m-1][n-1];
        }

X. DP O(N^2) space
https://discuss.leetcode.com/topic/7461/bottom-up-iterative-solution-o-mn-no-extra-space
public int uniquePathsWithObstacles(int[][] obstacleGrid) { int m = obstacleGrid.length; int n = obstacleGrid[0].length; for (int r = m - 1; r >= 0; r--) { for (int c = n - 1; c >= 0; c--) { if (obstacleGrid[r][c] == 1) obstacleGrid[r][c] = 0; else { if (r == m - 1 && c == n - 1) obstacleGrid[r][c] = 1; else if (r == m - 1) obstacleGrid[r][c] = obstacleGrid[r][c + 1]; else if (c == n - 1) obstacleGrid[r][c] = obstacleGrid[r + 1][c]; else obstacleGrid[r][c] = obstacleGrid[r][c + 1] + obstacleGrid[r + 1][c]; } } } return obstacleGrid[0][0]; }
https://leetcode.com/discuss/29816/short-java-solution
public int uniquePathsWithObstacles(int[][] obstacleGrid) { int m = obstacleGrid.length, n = obstacleGrid[0].length; //flip upper left cell (the start cell): 1 => 0 or 0 => 1 obstacleGrid[0][0] ^= 1; //first row: if 1, then 0; otherwise, left cell for(int i = 1; i < n; i++) obstacleGrid[0][i] = obstacleGrid[0][i] == 1 ? 0 : obstacleGrid[0][i - 1]; //first column: if 1, then 0; otherwise, top cell for(int i = 1; i < m; i++) obstacleGrid[i][0] = obstacleGrid[i][0] == 1 ? 0 : obstacleGrid[i - 1][0]; //rest: if 1, then 0; otherwise, left cell + top cell for(int i = 1; i < m; i++) for(int j = 1; j < n; j++) obstacleGrid[i][j] = obstacleGrid[i][j] == 1 ? 0 : obstacleGrid[i - 1][j] + obstacleGrid[i][j - 1]; //return lower right cell (the end cell) return obstacleGrid[m - 1][n - 1]; }
http://buttercola.blogspot.com/2014/09/leetcode-unique-paths-ii.html

    public int uniquePathsWithObstacles(int[][] obstacleGrid) {
        if (obstacleGrid == null || obstacleGrid.length == 0) {
            return 0;
        }
         
        int m = obstacleGrid.length;
        int n = obstacleGrid[0].length;
         
        if (obstacleGrid[0][0] == 1 || obstacleGrid[m - 1][n - 1] == 1) {
            return 0;//\\
        }
         
        int[] dp = new int[n];
        dp[0] = 1;
         
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (obstacleGrid[i][j] == 1) {
                    dp[j] = 0;
                } else if (j > 0) {
                    dp[j] = dp[j] + dp[j - 1];
                }
            }
        }
        return dp[n - 1];
    }
https://discuss.leetcode.com/topic/10974/short-java-solution
X. DP O(n) Space
https://discuss.leetcode.com/topic/10974/short-java-solution
public int uniquePathsWithObstacles(int[][] obstacleGrid) {
    int width = obstacleGrid[0].length;
    int[] dp = new int[width];
    dp[0] = 1;
    for (int[] row : obstacleGrid) {
        for (int j = 0; j < width; j++) {
            if (row[j] == 1)
                dp[j] = 0;
            else if (j > 0)
                dp[j] += dp[j - 1];
        }
    }
    return dp[width - 1];
}
code from http://www.darrensunny.me/leetcode-unique-paths-ii/
public int uniquePathsWithObstacles(int[][] obstacleGrid) {
        if (obstacleGrid == null || obstacleGrid.length == 0 ||
                obstacleGrid[0].length == 0)
            return 0;
        int m = obstacleGrid.length, n = obstacleGrid[0].length;
        int[] dp = new int[n+1];
        dp[1] = 1;      // Initialization: one unique path to the starting point
        // Compute the number of unique paths to obstacleGrid[i][j]
        // Normally, it equals to the sum of the number of unique paths to obstacleGrid[i][j-1]
        // and that to obstacleGrid[i-1][j], except the case when the cell contains obstacles
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                if (obstacleGrid[i][j] == 1)    // Obstacle
                    dp[j+1] = 0;    // Cannot reach a cell containing obstacle
                else        // Empty space
                    dp[j+1] += dp[j];
            }
        }
        return dp[n];
    }
Don't use extra space
Code from http://blog.csdn.net/kenden23/article/details/17317805
int uniquePathsWithObstacles(vector<vector<int> > &obstacleGrid) {
int r = obstacleGrid.size();
if (r < 1) return 1;
int c = obstacleGrid[0].size();
vector<int> table(c);
if (obstacleGrid[0][0] == 1) return 0;
else table[0] = 1;
for (int i = 1; i < c && obstacleGrid[0][i] != 1; i++)
{
table[i] = 1;
}
for (int i = 1; i < r; i++)
{
//注意:如果是只有单列的时候,每列需要初始化
//注意:不等于1的时候是填回上一列的值,并非初始化为1
if (obstacleGrid[i][0] == 1) table[0] = 0;
for (int j = 1; j < c; j++)
{
if (obstacleGrid[i][j] != 1)
table[j] += table[j-1];
else table[j] = 0;
}
}
return table[c-1];
}
O(m*N) space: Code 

    public int uniquePathsWithObstacles(int[][] obstacleGrid) {
        if (obstacleGrid == null || obstacleGrid.length == 0) {
            return 0;
        }
         
        int m = obstacleGrid.length;
        int n = obstacleGrid[0].length;
         
        if (obstacleGrid[0][0] == 1 || obstacleGrid[m - 1][n - 1] == 1) {
            return 0;
        }
         
        int[][] dp = new int[m][n];
         
        // check the first row
        for (int i = 0; i < n; i++) {
            if (obstacleGrid[0][i] == 0) {
                dp[0][i] = 1;
            } else {
                break;//\\
            }
        }
         
        // check the first column
        for (int i = 0; i < m; i++) {
            if (obstacleGrid[i][0] == 0) {
                dp[i][0] = 1;
            } else {
                break;//\\
            }
        }
         
        for (int i = 1; i < m; i++) {
            for (int j = 1; j < n; j++) {
                if (obstacleGrid[i][j] == 0) {
                    dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
                }
            }
        }
         
        return dp[m - 1][n - 1];
    }
from http://yucoding.blogspot.com/2013/04/leetcode-question-117-unique-path-ii.html
int uniquePathsWithObstacles(vector<vector<int> > &obstacleGrid) {
        // Start typing your C/C++ solution below
        // DO NOT write int main() function
        int m = obstacleGrid.size();
        int n = obstacleGrid[0].size();
         
        vector<vector<int> > arr(m,vector<int>(n,0));
         
        if (obstacleGrid[0][0]==1){return 0;}
        arr[0][0]=1;
        for (int i=1;i<m;i++){
            if (obstacleGrid[i][0]!=1){
                arr[i][0] = arr[i-1][0];
            }
        }
        for (int i=1;i<n;i++){
            if (obstacleGrid[0][i]!=1){
                arr[0][i] = arr[0][i-1];
            }
        }
        for (int i=1;i<m;i++){
            for(int j=1;j<n;j++){
                if (obstacleGrid[i][j]!=1){
                    arr[i][j] = arr[i][j-1] + arr[i-1][j];
                }
            }
        }  
        return arr[m-1][n-1];
    }

X. DFS + Cache
Note the difference between this solution with the Unique Path I, where as we start from (m, n) and ended with (m == 1 || n == 1). Why the previous method does not work here? That is because (m == 1 || n == 1) we cannot simply return 1 because there could be an obstacle in the last row or column. So we have to check until we reach the bottom-right point. 
    public int uniquePathsWithObstacles(int[][] obstacleGrid) {
        if (obstacleGrid == null || obstacleGrid.length == 0) {
            return 0;
        }
         
        int m = obstacleGrid.length;
        int n = obstacleGrid[0].length;
         
        if (obstacleGrid[0][0] == 1 || obstacleGrid[m - 1][n - 1] == 1) {
            return 0;
        }
         
        int[][] dp = new int[m][n];
         
        return uniquePathsHelper(0, 0, m, n, obstacleGrid, dp);
    }
     
    private int uniquePathsHelper(int m, int n, int rows, int cols, int[][] obstacleGrid, int[][] dp) {
        if (m > rows - 1 || n > cols- 1) {
            return 0;
        }
         
        if (obstacleGrid[m][n] == 1) {
            return 0;
        }
         
        if (m == rows - 1 && n == cols - 1) {
            return 1;
        }
         
         
        if (dp[m][n] != 0) {
            return dp[m][n];
        }
         
        dp[m][n] = uniquePathsHelper(m + 1, n, rows, cols, obstacleGrid, dp) + uniquePathsHelper(m, n + 1, rows, cols, obstacleGrid, dp);
        return dp[m][n];
    }
Read full article from LeetCode - Unique Paths II | Darren's Blog

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts